use argh::FromArgs;

use crate::api::ApiClient;
use crate::Error;
use crate::action::ActionExec;
use crate::config::Config;

#[derive(FromArgs, PartialEq, Debug)]
#[argh(subcommand, name = "list")]
/// list existing torrents on qBittorrent
pub struct ListAction {}

impl ActionExec for ListAction {
    fn exec(&self, config: &Config) -> Result<(), Error> {
        let api = ApiClient::from_config(&config)?;
        let res = api.list()?;
        println!("{}", res);
        Ok(())
    }
}
